exodus/analysis_query/urls.py
from django.conf import settings
from django.urls import path

from . import views

app_name = 'analysis'
urlpatterns = [
    path('', views.AnalysisRequestListView.as_view(), name='index'),
    path('submit/', views.AnalysisRequestView.as_view(), name='submit'),
    path('<int:r_id>/', views.wait, name='wait'),
    path('<int:r_id>/json/', views.json, name='json'),
]

if settings.ALLOW_APK_UPLOAD:
    urlpatterns.append(path('upload/', views.upload_file, name='upload'))

exodus/exodus/urls.py
from django.conf import settings
from django.urls import include, path
from django.conf.urls.i18n import i18n_patterns
from django.conf.urls.static import static
from django.contrib import admin

from . import views

urlpatterns = [
    path('i18n/', include('django.conf.urls.i18n')),
    path('api/', include('restful_api.urls')),
    path('admin/', admin.site.urls),
    path('api-auth/', include('rest_framework.urls', namespace='rest_framework')),
]

urlpatterns += i18n_patterns(
    path('', views.index, name='home'),
    path('analysis/', include('analysis_query.urls')),
    path('trackers/', include('trackers.urls')),
    path('reports/', include('reports.urls')),
    path('info/permissions/', views.permissions, name='permissions'),
    path('info/trackers/', views.trackers, name='trackers'),
    path('info/next/', views.next, name='next'),
    path('info/understand/', views.understand, name='understand'),
    path('info/organization/', views.organization, name='organization'),
)

urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

# handler404 = 'exodus.views.page_not_found'
# handler500 = 'exodus.views.page_not_found'

exodus/reports/urls.py
from django.urls import path
from django.views.generic import RedirectView

from . import views

app_name = 'reports'
urlpatterns = [
    path('', views.index, name='index'),
    path('list/', views.get_reports, name='list'),
    path('<int:report_id>/', views.detail, name='detail'),
    path('<int:app_id>/icon/', views.get_app_icon, name='icon'),
    path('stats/', RedirectView.as_view(pattern_name='trackers:get_stats', permanent=False)),
    path('search/<handle>/', views.get_reports, name='search_by_handle'),
    path('<handle>/latest/', views.detail, name='get_latest'),
    path('<handle>/latest/icon/', views.get_app_icon, name='icon_by_handle'),
]

exodus/analysis_query/models.py
# -*- coding: utf-8 -*-
from __future__ import unicode_literals

import re
import requests

from django.conf import settings
from django.core.exceptions import ValidationError
from django.db import models
from django.db.models.signals import pre_delete
from django.dispatch import receiver
from django.utils.translation import gettext_lazy as _

MAX_QUERIES = 19
PLAY_STORE_URL = 'https://play.google.com/store/apps/details?id='
FDROID_URL = 'https://f-droid.org/packages/'
FAKE_UA_HEADER = {
    'User-Agent':
    'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:64.0) Gecko/20100101 Firefox/64.0'
}


def _is_app_in_store(handle, store_url):
    r = requests.get(
        '{}{}'.format(store_url, handle),
        headers=FAKE_UA_HEADER,
        proxies={'http': settings.HTTP_PROXY, 'https': settings.HTTPS_PROXY}
    )
    return r.status_code != 404


def validate_handle(handle):
    """
    Validate the given handle
    Check regex, store urls, duplicate queries & total pending queries
    :param handle: application handle to validate
    :raise ValidationError: if any of the checks fails
    """
    package_reg = re.compile(r'^(\w+\.)+\w+$')
    if package_reg.match(handle) is None:
        error_msg = _(u'%s is not a valid application handle') % handle
        raise ValidationError(error_msg)

    found_on_gplay = _is_app_in_store(handle, PLAY_STORE_URL)
    if not found_on_gplay:
        found_on_fdroid = _is_app_in_store(handle, FDROID_URL)
        if not found_on_fdroid:
            raise ValidationError(
                _("The application '{}' cannot be found".format(handle)))

    duplicate_queries = AnalysisRequest.objects.filter(
        processed=False,
        handle=handle
    )
    if duplicate_queries.count() > 0:
        raise ValidationError(_('This application is being analyzed.'))

    pending_queries = AnalysisRequest.objects.filter(processed=False).count()
    if pending_queries > MAX_QUERIES:
        raise ValidationError(
            _('Too much pending requests, please retry later'))


def validate_file_extension(value):
    import os
    ext = os.path.splitext(value.name)[1]  # [0] returns path+filename
    valid_extensions = ['.apk', ]
    if not ext.lower() in valid_extensions:
        raise ValidationError(_('Unsupported file extension'))


class AnalysisRequest(models.Model):
    uploaded_at = models.DateTimeField(auto_now_add=True)
    bucket = models.CharField(max_length=200, default='')
    handle = models.CharField(max_length=500, default='', blank=True, validators=[validate_handle])
    description = models.TextField(blank=True)
    processed = models.BooleanField(default=False)
    in_error = models.BooleanField(default=False)
    report_id = models.CharField(max_length=200, default='')
    apk = models.FileField(blank=False, validators=[validate_file_extension])
    source = models.CharField(max_length=50, default='')


@receiver(pre_delete, sender=AnalysisRequest)
def analysis_request_delete(sender, instance, **kwargs):
    instance.apk.delete(False)

exodus/analysis_query/forms.py
# -*- coding: utf-8 -*-
from django import forms

from .models import AnalysisRequest


class AnalysisRequestForm(forms.ModelForm):
    class Meta:
        model = AnalysisRequest
        fields = ('handle', 'source')


class UploadRequestForm(forms.ModelForm):
    class Meta:
        model = AnalysisRequest
        fields = ('apk', )

exodus/analysis_query/views.py
# -*- coding: utf-8 -*-
from __future__ import unicode_literals

import random
import string

from django.conf import settings
from django.http import HttpResponseRedirect
from django.http import JsonResponse
from django.http.response import Http404
from django.shortcuts import render
from django.urls import reverse
from django.utils.translation import gettext_lazy as _
from django.views.generic import FormView, ListView

from exodus.core.apk import StaticAnalysisParameters, start_static_analysis

from .forms import AnalysisRequestForm, UploadRequestForm
from .models import AnalysisRequest


def random_word(length):
    return ''.join(random.choice(string.ascii_lowercase) for _ in range(length))


def upload_file(request):
    if request.method == 'POST' and settings.ALLOW_APK_UPLOAD:
        form = UploadRequestForm(request.POST, request.FILES)
        if form.is_valid():
            req = form.save()
            req.handle = 'from_upload'
            req.source = 'apk'
            req.bucket = str(random_word(60))
            req.description = _('Your request will be handled soon')
            req.save()

            params = StaticAnalysisParameters(req)
            start_static_analysis.delay(params)
            return HttpResponseRedirect(reverse('analysis:wait', args=[req.id]))

    else:
        form = UploadRequestForm()
    return render(request, 'query_upload.html', {'form': form})


class AnalysisRequestView(FormView):
    template_name = 'query_submit.html'
    form_class = AnalysisRequestForm

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['upload_allowed'] = settings.ALLOW_APK_UPLOAD
        return context

    def form_valid(self, form):
        randhex = str(random_word(60))
        req = AnalysisRequest(
            handle=form.cleaned_data['handle'],
            source=form.cleaned_data['source'],
            bucket=randhex,
            description=_('Your request will be handled soon')
        )
        req.save()

        params = StaticAnalysisParameters(req)
        start_static_analysis.delay(params)

        return HttpResponseRedirect(reverse('analysis:wait', args=[req.id]))


def wait(request, r_id):
    try:
        r = AnalysisRequest.objects.get(pk=r_id)
    except AnalysisRequest.DoesNotExist:
        raise Http404(_("AnalysisRequest does not exist"))
    return render(request, 'query_wait.html', {'request': r})


def json(request, r_id):
    try:
        r = AnalysisRequest.objects.get(pk=r_id)
    except AnalysisRequest.DoesNotExist:
        raise Http404(_("AnalysisRequest does not exist"))

    obj = {
        'description': _(r.description),
        'bucket': '',
        'processed': r.processed,
        'in_error': r.in_error,
        'report_id': r.report_id,
    }

    return JsonResponse(obj, safe=False)


class AnalysisRequestListView(ListView):
    template_name = 'queries_list.html'
    context_object_name = 'queries'

    def get_queryset(self):
        return AnalysisRequest.objects.order_by('-uploaded_at')[:200]

exodus/analysis_query/templates/queries_list.html
{% extends "base/base.html"%}
{% load i18n %}
{% block content %}
<div class="row justify-content-md-center">
  <div class="col-lg-10 col-centered">
    {% if request.user.is_superuser %}
      <table class="table table-hover">
        {% for q in queries %}
          <tr>
            <td>
              <a href="{% url 'analysis:wait' q.id %}">{{ q.id }}</a>
            </td>
            <td>
              {% if q.source == 'fdroid' %}
                <a target="_blank" rel="noreferrer" href="https://f-droid.org/packages/{{ q.handle }}">{{ q.handle | truncatechars_html:40 }}</a>
              {% else %}
                <a target="_blank" rel="noreferrer" href="https://play.google.com/store/apps/details?id={{ q.handle }}">{{ q.handle | truncatechars_html:40 }}</a>
              {% endif %}
            </td>
            <td>
              {{ q.source }}
            </td>
            <td>
              {{ q.uploaded_at }}
            </td>
            <td>
              {% if q.processed %}
                {% if q.in_error %}
                  <span class="text-danger" data-toggle="tooltip" title="{{ q.description }}">error</span>
                {% else %}
                  <span class="text-success">complete</span>
                {% endif %}
              {% else %}
                <span class="text-warning">in progress</span>
              {% endif %}
            </td>
          </tr>
        {% endfor %}
      </table>
    {% else %}
      <div class="alert alert-danger small">
        <strong>{% trans "You need to be registered" %}.</strong>
      </div>
    {% endif %}
  </div>
</div>
{% endblock %}

exodus/analysis_query/templates/query_error.html
{% extends "base/base.html"%}
{% block content %}
  <div class="row justify-content-sm-center">
    <div class="col-md-8 col-12 col-centered">
      <div class="alert alert-danger text-center" role="alert">
        {% if error %}
          {{ error }}
        {% endif %}
      </div>
    </div>
  </div>
{% endblock %}

exodus/analysis_query/templates/query_submit.html
{% extends "base/base.html"%}
{% load i18n %}
{% load static %}
{% get_current_language as LANGUAGE_CODE %}
{% block content %}
<div class="row justify-content-sm-center">
  <div class="col-md-8 col-12 text-center mb-4">
    <h1 class="main-title">
      {% trans "New analysis" %}
    </h1>
  </div>
</div>

<div class="row justify-content-sm-center">
  <div class="col-md-8 col-12">
    <p class="text-center mb-5">
      <img src="{% static 'img/analysis_new.png' %}" width="120">
    </p>
    <form method="post" enctype="multipart/form-data" action="{% if LANGUAGE_CODE in 'fr,en' %}{% url 'analysis:submit' %}{% else %}/en/analysis/submit/{% endif %}">
      <div class="form-group">
        {% csrf_token %}
        {% if form.errors %}
          {% for field in form %}
            {% for error in field.errors %}
              <div class="alert alert-danger small">
                <strong>{{ error|escape }}</strong>
              </div>
            {% endfor %}
          {% endfor %}
        {% endif %}
        <label for="handle"><b>{% trans "URL of the application" %}</b></label>
        <div class="input-group input-group-lg mb-3">
          <div class="input-group-prepend">
            <span class="input-group-text" id="handle_help">
              <small><img src="/static/img/search.svg"></small>
            </span>
          </div>
          <input type="text" class="form-control" id="handle" name="handle" aria-describedby="handle_help" required>
        </div>
        <label for="source" class="col-form-label"><b>{% trans "Source:" %}</b> </label>
        <div class="form-check form-check-inline">
          <input class="form-check-input" type="radio" name="source" id="sourceGoogle" value="google" checked>
          <label class="form-check-label" for="sourceGoogle">Google Play</label>
        </div>
        <div class="form-check form-check-inline">
          <input class="form-check-input" type="radio" name="source" id="sourceFdroid" value="fdroid">
          <label class="form-check-label" for="sourceFdroid">F-Droid</label>
        </div>
        <p class="form-text text-muted mb-4">
          {% trans "Free applications only. Works also with the application handle." %}
        </p>
        <div class="alert alert-warning text-center mb-4" role="alert">
          Applications with geographic restrictions cannot be scanned -
          read our <a target="_blank" rel="noreferrer" href='https://exodus-privacy.eu.org/en/post/covid/'>blog post</a>
        </div>

        <div id="reports" style="display: none" class="alert alert-info">
        </div>

        <div class="row justify-content-center mb-5">
          <div class="col-8 col-sm-7 col-md-6 col-xl-5">
            <button type='submit' onclick="show_spinner()" class="btn btn-primary btn-block">{% trans "Perform analysis" %}</button>
          </div>
        </div>

        {% if upload_allowed %}
          <p class="text-right">
            <a class="link main-link" href="{% url 'analysis:upload' %}">{% trans "I prefer to upload an application" %}</a>
          </p>
        {% endif %}

        <div id="loading" class="text-center" style="display:none;">
          <img style="width:200px;" src="/static/img/loading.gif" alt="">
          <div class="alert alert-light" role="alert">
            {% trans "The analysis could take a long time, you will be automatically redirected to the report." %}
          </div>
        </div>
      </div>
    </form>
  </div>
</div>

<div class="row justify-content-sm-center mt-5">
  <div class="col-md-8 col-12 col-centered">
    <div class="text-center alert alert-light">
      <p>
        <a href="{% url 'organization' %}">Exodus Privacy</a>
        {% trans "is a non-profit organization which provides this service for free." %}
      </p>
      <a class="btn btn-outline-primary" href="https://exodus-privacy.eu.org/{% if LANGUAGE_CODE == 'fr' %}fr{% else %}en{% endif %}/page/contribute/" target="_blank" rel="noreferrer">{% trans "Help us!" %}</a>
    </div>
  </div>
</div>
{% endblock %}

{% block scripts %}
<script>
  // Spinner
  var show_spinner = function () {
    if ($("#handle").val()) {
      var s = document.getElementById("loading")
      if (s != undefined) {
        s.style.display = "block"
      }
    }
  }

  // dirty hack to get correct report url dynamically
  var get_report_reverse_url = function (id) {
    return "{% url 'reports:detail' report_id='112233' %}".replace("112233", id)
  }

  var check_existing_report = function (handle) {
    const regex_pk = /^((?:\w+\.)+\w+)$/gmi;
    if (regex_pk.test(handle)) {
      jQuery.get("/api/search/" + handle + "/latest", function (rq) {
        if (rq.id) {
          jQuery("#reports").html('')
          jQuery("#reports").show()

          var p = document.createElement('p')
          var name = handle
          if (rq.name != '') {
            name = rq.name
          }
          p.innerHTML = "<b>{% trans  'This application has already been analyzed!' %}</b>"
          jQuery("#reports").append(p)

          var report_date = rq.creation_date.substring(0, 10)
          var p2 = document.createElement('p')
          var report_url = get_report_reverse_url(rq.id)
          p2.innerHTML = name + " - {% trans 'analyzed on' %} " + report_date + " - <a href='" + report_url + "'>{% trans 'Go to the latest report' %}</a>"
          jQuery("#reports").append(p2)

          var p3 = document.createElement('p')
          p3.innerHTML = "{% trans 'If you think εxodus has not yet analyzed the latest version of this application, feel free to submit the analysis.' %}"
          jQuery("#reports").append(p3)
        }
      })
    }
  }

  jQuery("#handle").on("input", function () {
    // Extract handle from Google Play or F-Droid url
    const gplay_regex = /id=((?:\w+\.)+\w+)/gmi;
    const fdroid_regex = /packages\/((?:\w+\.)+\w+)/gmi;
    const handle = jQuery.trim(jQuery(this).val())
    jQuery("#reports").hide()
    if (handle.startsWith("https://play.google.com")) {
      var match = gplay_regex.exec(handle)
      while (match != null) {
        if (match[1]) {
          $(this).val(match[1])
          $('#sourceGoogle')[0].checked = true;
          check_existing_report(match[1])
        }
        return
      }
    } else if (handle.startsWith("https://f-droid.org/")) {
      var match = fdroid_regex.exec(handle)
      while (match != null) {
        if (match[1]) {
          $(this).val(match[1])
          $('#sourceFdroid')[0].checked = true;
          check_existing_report(match[1])
        }
        return
      }
    } else {
      check_existing_report(handle)
    }
  });

  var given_handle = window.location.hash.substr(1); // substr(1) removes the #
  if (given_handle) {
    jQuery("#handle").val(given_handle)
    check_existing_report(given_handle)
  }
</script>
{% endblock %}

exodus/analysis_query/templates/query_upload.html
{% extends "base/base.html"%}
{% load i18n %}
{% load static %}
{% get_current_language as LANGUAGE_CODE %}
{% block content %}
<div class="row justify-content-sm-center">
  <div class="col-md-8 col-12 text-center mb-4">
    <h1 class="main-title">
      {% trans "New analysis" %}
    </h1>
  </div>
</div>

<div class="row justify-content-sm-center">
  <div class="col-md-8 col-12">
    <p class="text-center mb-5">
      <img src="{% static 'img/analysis_new.png' %}" width=120px>
    </p>
    <form method="post" enctype="multipart/form-data" action="{% url 'analysis:upload' %}">
      <div class="form-group">
        {% csrf_token %}
        {% if form.errors %}
          {% for field in form %}
            {% for error in field.errors %}
              <div class="alert alert-danger small">
                <strong>{{ error|escape }}</strong>
              </div>
            {% endfor %}
          {% endfor %}
        {% endif %}

        <label for="apk_file_name"><b>{% trans "Upload an application" %}</b></label>
        <div class="input-group">
          <label class="input-group-btn">
              <span class="btn btn-primary">
                  {% trans "Browse file" %}<input type="file" required name="apk" id="id_apk" style="display: none;">
              </span>
          </label>
          <input id="apk_file_name" type="text" class="form-control" readonly>
        </div>
        <p class="form-text text-muted mb-4">
          {% trans "Only works with APK files." %}
        </p>

        <div id="reports" style="display: none" class="alert alert-info">
        </div>

        <div class="row justify-content-center mb-5">
          <div class="col-8 col-sm-7 col-md-6 col-xl-5">
            <button type='submit' onclick="show_spinner()" class="btn btn-primary btn-block">{% trans "Perform analysis" %}</button>
          </div>
        </div>

        <div id="loading" class="text-center" style="display:none;">
          <img style="width:200px;" src="/static/img/loading.gif" alt="">
          <div class="alert alert-light" role="alert">
            {% trans "The analysis could take a long time, you will be automatically redirected to the report." %}
          </div>
        </div>
      </div>
    </form>
  </div>
</div>

<div class="row justify-content-sm-center mt-5">
  <div class="col-md-8 col-12 col-centered">
    <div class="text-center alert alert-light">
      <p>
        <a href="{% url 'organization' %}">Exodus Privacy</a>
        {% trans "is a non-profit organization which provides this service for free." %}
      </p>
      <a class="btn btn-outline-primary" href="https://exodus-privacy.eu.org/{% if LANGUAGE_CODE == 'fr' %}fr{% else %}en{% endif %}/page/contribute/" target="_blank" rel="noreferrer">{% trans "Help us!" %}</a>
    </div>
  </div>
</div>
{% endblock %}

{% block scripts %}
<script>
// Spinner
var show_spinner=function(){
  if( $("#apk_file_name").val() ) {
    var s = document.getElementById("loading")
    if(s != undefined){
      s.style.display = "block"
    }
  }
}
$(function() {
  $(document).on('change', ':file', function() {
    var input = $(this),
        label = input.val().replace(/\\/g, '/').replace(/.*\//, '');
    input.trigger('fileselect', label);
    $("#handle")[0].value = ""
  });

  $(document).ready( function() {
      $(':file').on('fileselect', function(event, label) {
          var input = $(this).parents('.input-group').find(':text')
          input.val(label)
      });
  });
});
</script>
{% endblock %}

exodus/analysis_query/templates/query_wait.html
{% extends "base/base.html"%}
{% load i18n %}
{% load static %}
{% get_current_language as LANGUAGE_CODE %}
{% block content %}
<div class="row justify-content-sm-center">
  <div class="col-md-8 col-12 text-center mb-4">
    <h1 id="main-title" class="main-title">
      {% trans "Analysis in progress..." %}
    </h1>
  </div>
</div>

<div class="row justify-content-sm-center">
  <div class="col-md-8 col-12 col-centered mb-4">
    <div id="loading" class="text-center" style="">
      <div id="description" class="alert alert-info" role="alert">
        {% trans request.description %}
      </div>
      <p id="completed" style="display:none" class="text-center mt-5">
        <img src="{% static 'img/analysis_completed.png' %}" width="120">
      </p>
      <p id="report" style="display:none" class="mt-4">
        <a href="#" class="btn btn-primary">{% trans "See the report" %}</a>
      </p>
      <img id="snake" style="display:none" style="width:200px;" src="/static/img/loading.gif" alt="">
      <div id="refresh" class="text-muted small">
        {% trans "Will refresh automatically every 10 seconds." %}
      </div>
    </div>
  </div>
</div>

<div class="row justify-content-md-center mt-5">
  <div class="col-lg-8 col-sm-10 col-centered">
    <div class="text-center alert alert-light">
      <p>
        <a href="{% url 'organization' %}">Exodus Privacy</a>
        {% trans "is a non-profit organization which provides this service for free." %}
      </p>
      <a class="btn btn-outline-primary" href="https://exodus-privacy.eu.org/{% if LANGUAGE_CODE == 'fr' %}fr{% else %}en{% endif %}/page/contribute/" target="_blank" rel="noreferrer">{% trans "Help us!" %}</a>
    </div>
  </div>
</div>
{% endblock %}


{% block scripts %}
<script>
  const refresh = function(){
    console.log("Refresh")

    jQuery.get("/analysis/{{request.id}}/json", function(rq){
      jQuery("#description").removeClass("alert-danger alert-info")
      jQuery("#description").html(rq.description)
      if(rq.in_error){
        jQuery("#description").addClass("alert-danger")
      } else {
        jQuery("#description").addClass("alert-info")
      }
      if(rq.processed){
        jQuery("#snake").hide()
        jQuery("#refresh").hide()
        jQuery("#main-title").text("{% trans 'Analysis done!' %}")
        jQuery("#completed").show()
        if(!rq.in_error){
          jQuery("#report").children(":first").attr("href", "/reports/"+rq.report_id+"/")
          jQuery("#report").show()
        }
      } else {
        jQuery("#snake").show()
        jQuery("#report").hide()
        setTimeout(function () {
          refresh()
        }, 10 * 1000);
      }
    })
  }
  refresh()
</script>
{% endblock %}